--
--	TempTic -  a small addon that tracks buff timers and HoTs for healers that 
--	use skills from the restoration staff and Templar restoring light skill lines. 
--
--	filename: TempTic.lua
--	(c) meaghs .  http://relicgaming.guildlaunch.com
--
--	This Add-on is not created by, affiliated with or sponsored by ZeniMax Media 
--	Inc. or its affiliates. The Elder Scrolls and related logos are registered 
--	trademarks or trademarks of ZeniMax Media Inc. in the United States and/or 
--	other countries. All rights reserved.
--
--	*pardon messy code - work in progress... part-time work anyways.. when not in eso

	HonorTheDead_TempTic_GVAR = 'Honor The Dead'
	RushedCeremony_TempTic_GVAR = 'Rushed Ceremony'
	LingeringRitual_TempTic_GVAR = 'Lingering Ritual'
	HealingRitual_TempTic_GVAR = 'Healing Ritual' -- purifying clensing & Extended Ritual as Healing Ritual?
	RapidRegeneration_TempTic_GVAR = 'Rapid Regeneration' -- not picking up
	RestoringAura_TempTic_GVAR = 'Restoring Aura' -- not picking up
	Mutagen_TempTic_GVAR = 'Mutagen'
	Blessing_of_Protection_GVAR = 'Blessing of Protection'
	Repentance_GVAR = 'Repentance Heal'
	Blessing_of_Restoration_GVAR = 'Blessing Of Restoration'
	Steadfast_Ward_GVAR = 'Steadfast Ward'

	-- Initialize Times for first usage
	HTDCastTime_TempTic_GVAR = 0 
	LRCastTime_TempTic_GVAR = 0
	HRCastTime_TempTic_GVAR = 0
	MutCastTime_TempTic_GVAR = 0
	BoPCastTime_TempTic_GVAR = 0
	SWCastTime_TempTic_GVAR = 0

	RCCastTime_TempTic_GVAR = 0
	RRCastTime_TempTic_GVAR = 0
	RepCastTime_TempTic_GVAR = 0



function TempTicMain()	

	EVENT_MANAGER:RegisterForEvent ( 'TempTic', EVENT_COMBAT_EVENT, registerHeal_TempTic_FUNC )

end

function registerHeal_TempTic_FUNC ( eventCode , result , isError , abilityName, abilityGraphic, abilityActionSlotType, sourceName, sourceType, targetName, targetType, hitValue, powerType, damageType, log )

	-- Modify the ability name so its sexy
	local abilityName_TempTic_LVAR = string.gsub ( abilityName , ' %(.*%)' , "" )
	local nicename = string.gsub( GetUnitName( 'player' ) , "%-", "%%%-")

	-- Decided to take this out. Damage filter / results should not be in TempTic's purview.
--	if FTCDamageFilter( result , abilityName , sourceType , sourceName , targetName , hitValue ) then
--		TempTicCTLLabelPipe:SetText(string.format("%s  %d", abilityName_TempTic_LVAR, hitValue))
		--check to clear pipe if not in combat
--		zo_callLater(function() clearPipe_FUNC() end, 5000)
--	end

	if ( string.match( sourceName , nicename ) ) then
		-- Initialize Labels and on first usage
		if ( string.match ( Blessing_of_Protection_GVAR, abilityName_TempTic_LVAR ) ) or ( string.match ( Blessing_of_Restoration_GVAR, abilityName_TempTic_LVAR ) )then 
			TempTicCTLLabelBoP:SetColor(0,255,0,255)
			BoPCastTime_TempTic_GVAR = 1
			TempTicCTLLabelBoP:SetText(string.format("%s", abilityName_TempTic_LVAR))
			zo_callLater(function() BoPTimeOut_TempTic_FUNC() end, 8000)
			return
		end

		--steadfast ward not working... or is unreliable anyways...
		if ( string.match ( Steadfast_Ward_GVAR, abilityName_TempTic_LVAR ) ) then 
			TempTicCTLLabelSW:SetColor(0,255,0,255)
			SWCastTime_TempTic_GVAR = 1
			TempTicCTLLabelSW:SetText(string.format("%s", abilityName_TempTic_LVAR))
			zo_callLater(function() SWTimeOut_TempTic_FUNC() end, 6000)
			return
		end

		if ( string.match ( Mutagen_TempTic_GVAR, abilityName_TempTic_LVAR ) ) or ( string.match ( RapidRegeneration_TempTic_GVAR, abilityName_TempTic_LVAR ) ) then 
			TempTicCTLLabelMut:SetColor(0,255,0,255)
			MutCastTime_TempTic_GVAR = 1
			TempTicCTLLabelMut:SetText(string.format("%s", abilityName_TempTic_LVAR))
			zo_callLater(function() MutTimeOut_TempTic_FUNC() end, 20000)
			return
		end
		
		--going to put this out at Cleansing Ritual?
		if ( string.match ( HealingRitual_TempTic_GVAR, abilityName_TempTic_LVAR ) ) then 
			TempTicCTLLabelHR:SetColor(0,255,0,255)
			TempTicCTLLabelHR:SetText(string.format("Cleansing / %s", abilityName_TempTic_LVAR))
			HRCastTime_TempTic_GVAR = 1
			zo_callLater(function() HRTimeOut_TempTic_FUNC() end, 16000)
			return
		end
	end

end

--function clearPipe_FUNC()
--	if IsUnitInCombat("player") == false then
--		PipeTimeOut_TempTic_FUNC()
--	else
--		zo_callLater(function() clearPipe_FUNC() end, 5000)
--	end
--end

-- modified FTC.Damage:Filter function from the FTC mod by atropos; used with permission.

function FTCDamageFilter( result , abilityName , sourceType , sourceName , targetName , hitValue )

	nicename = string.gsub( GetUnitName( 'player' ) , "%-", "%%%-")

	-- Ignore zero damage
	if ( hitValue == 0 ) then return false
	
	-- Only count damage related to the player
	elseif ( string.match( targetName , nicename ) == nil and string.match( sourceName , nicename ) == nil ) then return false
		
	-- Ignore Self-Harm
	elseif ( sourceType == 1 ) and ( string.match( targetName , nicename ) ~= nil ) and ( result ~= ACTION_RESULT_HEAL and result ~= ACTION_RESULT_HOT_TICK ) then return false

	-- Direct Damage
	elseif ( result == ACTION_RESULT_DAMAGE or result == ACTION_RESULT_CRITICAL_DAMAGE or result == ACTION_RESULT_BLOCKED_DAMAGE or result == ACTION_RESULT_FALL_DAMAGE ) then return true
	
	-- Damage Over Time
	elseif ( result == ACTION_RESULT_DOT_TICK or result == ACTION_RESULT_DOT_TICK_CRITICAL ) then return true
	
	-- Heals
	elseif ( result == ACTION_RESULT_HEAL or result == ACTION_RESULT_CRITICAL_HEAL or result == ACTION_RESULT_HOT_TICK ) then return true
		
	-- Damage Immunity
	elseif ( result == ACTION_RESULT_IMMUNE ) then return true

	-- Otherwise, ignore it
	else return false end	
end


function MutTimeOut_TempTic_FUNC()
	TempTicCTLLabelMut:SetText(string.format(""))
	MutCastTime_TempTic_GVAR = 0
end

function HRTimeOut_TempTic_FUNC()
	TempTicCTLLabelHR:SetText(string.format(""))
	HRCastTime_TempTic_GVAR = 0
end

function BoPTimeOut_TempTic_FUNC()
	TempTicCTLLabelBoP:SetText(string.format(""))
	BoPCastTime_TempTic_GVAR = 0
end

function PipeTimeOut_TempTic_FUNC()
	TempTicCTLLabelPipe:SetText(string.format(""))
end

function SWTimeOut_TempTic_FUNC()
	TempTicCTLLabelSW:SetText(string.format(""))
	SWCastTime_TempTic_GVAR = 0
end
